> ## Documentation Index
> Fetch the complete documentation index at: https://veryfront.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List run events

> List run events.



## OpenAPI

````yaml /cloud/rest/openapi.json get /runs/{run_id}/events
openapi: 3.1.0
info:
  title: Veryfront REST API reference
  version: 1.0.0
  description: |-
    ## Explore the API

    | Domain | Use it to |
    | --- | --- |
    | [Projects](#tag/projects) | Manage projects and files. |
    | [Agents](#tag/agents) | Manage agent primitives. |
    | [Orchestration](#tag/execution) | Manage conversations and runs. |
    | [Evaluations](#tag/evaluations) | Manage evaluations and results. |
    | [AI Gateway](#tag/ai-gateway) | Access models and inference. |
    | [MCP](#tag/mcp) | Discover tools and authorization. |
    | [Integrations](#tag/integrations) | Manage connections and integrations. |
    | [Knowledge](#tag/knowledge) | Manage documents and search. |
    | [Deployments](#tag/deployments) | Manage releases and deployments. |
    | [Runtime](#tag/runtime) | Manage environments and infrastructure. |
    | [Observability](#tag/observability) | Monitor activity and performance. |
    | [Identity & Access](#tag/identity-access) | Manage identity and access. |
    | [Billing & Usage](#tag/billing-usage) | Manage billing and usage. |
    | [Other](#tag/platform) | Inspect health and API metadata. |

    [OpenAPI specification (JSON)](/openapi.json)
  contact:
    name: Veryfront API Support
    url: https://veryfront.com/docs
    email: support@veryfront.com
  x-api-id: 5f1f0b8a-6b0e-4c1a-9b35-0f3a1e6d84c7
  x-audience: external-public
servers:
  - url: https://api.veryfront.com
security:
  - bearerAuth: []
  - apiKeyAuth: []
tags:
  - name: projects
    description: Manage projects and files.
  - name: agents
    description: Manage agent primitives.
  - name: execution
    description: Manage conversations and runs.
  - name: evaluations
    description: Manage evaluations and results.
  - name: ai-gateway
    description: Access models and inference.
  - name: mcp
    description: Discover tools and authorization.
  - name: integrations
    description: Manage connections and integrations.
  - name: knowledge
    description: Manage documents and search.
  - name: deployments
    description: Manage releases and deployments.
  - name: runtime
    description: Manage environments and infrastructure.
  - name: observability
    description: Monitor activity and performance.
  - name: identity-access
    description: Manage identity and access.
  - name: billing-usage
    description: Manage billing and usage.
  - name: platform
    description: Inspect health and API metadata.
  - name: projects/Projects
  - name: projects/Projects/Favorites
  - name: projects/Projects/Account Projects
  - name: projects/Projects/Projects
  - name: projects/Projects/Project Labels
  - name: projects/Projects/Project templates
  - name: projects/Files
  - name: projects/Files/Files
  - name: projects/Files/File Chunks
  - name: projects/Files/Branch File Versions
  - name: projects/Files/Branch Files
  - name: projects/Files/Environment Files
  - name: projects/Files/File Versions
  - name: projects/Files/Branch File Drafts
  - name: projects/Files/Release Files
  - name: projects/Files/Sandbox Files
  - name: projects/Files/File Search
  - name: projects/Branches
  - name: projects/Branches/Branches
  - name: projects/Branches/Branch Policies
  - name: projects/Branches/Branch Approvals
  - name: projects/Branches/Branch Status Checks
  - name: projects/Branches/Project Commits
  - name: projects/Branches/Branch Merges
  - name: projects/Uploads
  - name: projects/Uploads/Upload Folders
  - name: projects/Uploads/Upload Grants
  - name: projects/Uploads/Project Uploads
  - name: projects/Uploads/Upload Visibility
  - name: agents/Agents
  - name: agents/Agents/Agents
  - name: agents/Agents/Agent Labels
  - name: agents/Agents/Agent templates
  - name: agents/Agents/Agent Tool References
  - name: agents/Agents/Agent Avatars
  - name: agents/Agents/Agent Capabilities
  - name: agents/Agents/Agent Installation
  - name: agents/Prompts
  - name: agents/Prompts/Project prompts
  - name: agents/Tools
  - name: agents/Tools/Project tools
  - name: agents/Skills
  - name: agents/Skills/Project skills
  - name: agents/Resources
  - name: agents/Resources/Project resources
  - name: agents/Tasks
  - name: agents/Tasks/Tasks
  - name: agents/Workflows
  - name: agents/Workflows/Workflows
  - name: execution/Conversations
  - name: execution/Conversations/Conversations
  - name: execution/Conversations/Conversation messages
  - name: execution/Conversations/Conversation participants
  - name: execution/Conversations/Conversation read state
  - name: execution/Triggers
  - name: execution/Triggers/Project schedules
  - name: execution/Triggers/Webhooks
  - name: execution/Triggers/Webhook events
  - name: execution/Runs
  - name: execution/Runs/Run Input Requests
  - name: execution/Runs/Runs
  - name: execution/Runs/Runtime
  - name: execution/Runs/Child Runs
  - name: execution/Runs/Conversation Runs
  - name: execution/Runs/Project Runs
  - name: execution/Runs/Webhook Runs
  - name: execution/Runs/Run Events
  - name: execution/Runs/Run Actions
  - name: execution/Runs/Run Artifacts
  - name: execution/Executors
  - name: execution/Executors/Connected agents
  - name: execution/Executors/Agent workers
  - name: evaluations/Evaluations
  - name: evaluations/Evaluations/Evaluations
  - name: evaluations/Evaluations/Evaluation Runs
  - name: ai-gateway/Models
  - name: ai-gateway/Models/Model discovery
  - name: ai-gateway/Models/Inference Models
  - name: ai-gateway/Models/Project inference policy
  - name: ai-gateway/Models/Account inference policy
  - name: ai-gateway/Inference
  - name: ai-gateway/Inference/OpenAI Chat Completions
  - name: ai-gateway/Inference/Embeddings
  - name: ai-gateway/Inference/OpenAI Responses
  - name: ai-gateway/Inference/Proxy metadata
  - name: ai-gateway/Inference/Anthropic Messages
  - name: ai-gateway/Inference/Provider gateway
  - name: ai-gateway/Inference/Gemini inference
  - name: ai-gateway/Inference/Image generation
  - name: mcp/Tools
  - name: mcp/Tools/MCP discovery
  - name: mcp/Authorization
  - name: mcp/Authorization/Protected resource discovery
  - name: integrations/Integrations
  - name: integrations/Integrations/Integration tools
  - name: integrations/Integrations/Integration catalog
  - name: integrations/Integrations/Project integrations
  - name: integrations/Connections
  - name: integrations/Connections/Connections
  - name: integrations/Channels
  - name: integrations/Channels/Channels
  - name: integrations/Channels/Setup lookups
  - name: integrations/External storage
  - name: integrations/External storage/External Files
  - name: knowledge/Documents
  - name: knowledge/Documents/Project knowledge
  - name: knowledge/Documents/Retrieval documents
  - name: knowledge/Search
  - name: knowledge/Search/Search
  - name: knowledge/Embeddings
  - name: knowledge/Embeddings/Project embeddings
  - name: deployments/Releases
  - name: deployments/Releases/Releases
  - name: deployments/Releases/Release Versions
  - name: deployments/Releases/Release Source Manifests
  - name: deployments/Deployments
  - name: deployments/Deployments/Project deployments
  - name: deployments/Artifacts
  - name: deployments/Artifacts/Dependencies
  - name: deployments/Artifacts/Release Asset Manifests
  - name: deployments/Artifacts/Style artifacts
  - name: runtime/Environments
  - name: runtime/Environments/Environments
  - name: runtime/Environments/Environment Domains
  - name: runtime/Environments/Environment variables
  - name: runtime/Environments/Project Domains
  - name: runtime/Environments/Environment Variable Keys
  - name: runtime/Servers
  - name: runtime/Servers/Environment Servers
  - name: runtime/Servers/Project servers
  - name: runtime/Sandboxes
  - name: runtime/Sandboxes/Sandbox Lifecycle
  - name: runtime/Sandboxes/Sandbox Commands
  - name: runtime/Sandboxes/Sandbox Environment
  - name: runtime/Sandboxes/Sandbox Health
  - name: runtime/Sandboxes/Sandbox Terminal
  - name: runtime/Cache
  - name: runtime/Cache/Project Cache
  - name: runtime/Cache/User Cache
  - name: observability/Logs
  - name: observability/Logs/Log entries
  - name: observability/Traces
  - name: observability/Traces/Trace spans
  - name: observability/Traces/Project traces
  - name: observability/Traces/Trace Search
  - name: observability/Metrics
  - name: observability/Metrics/Metric series
  - name: observability/Alerts
  - name: observability/Alerts/Project alerts
  - name: observability/Error types
  - name: observability/Error types/Error types
  - name: identity-access/Users
  - name: identity-access/Users/Account users
  - name: identity-access/Users/Project users
  - name: identity-access/Users/Current user
  - name: identity-access/Accounts
  - name: identity-access/Accounts/Accounts
  - name: identity-access/Invitations
  - name: identity-access/Invitations/Invitations
  - name: identity-access/Permissions
  - name: identity-access/Permissions/Feature gates
  - name: identity-access/Permissions/Project Ownership
  - name: identity-access/API keys
  - name: identity-access/API keys/API keys
  - name: identity-access/Authentication
  - name: identity-access/Authentication/Sign-in
  - name: identity-access/Authentication/Tokens
  - name: identity-access/Authorization
  - name: identity-access/Authorization/Authorized apps
  - name: identity-access/Authorization/General OAuth
  - name: identity-access/Authorization/Consent
  - name: billing-usage/Subscriptions
  - name: billing-usage/Subscriptions/Subscriptions
  - name: billing-usage/Subscriptions/Seats
  - name: billing-usage/Billing
  - name: billing-usage/Billing/Invoices
  - name: billing-usage/Billing/Payments
  - name: billing-usage/Billing/Payment Methods
  - name: billing-usage/Billing/Billing Details
  - name: billing-usage/Billing/Account billing
  - name: billing-usage/Credits
  - name: billing-usage/Credits/Credits
  - name: billing-usage/Budgets
  - name: billing-usage/Budgets/Budgets
  - name: billing-usage/Usage
  - name: billing-usage/Usage/API key usage
  - name: billing-usage/Usage/Account usage
  - name: billing-usage/Usage/Project usage
  - name: billing-usage/Analytics
  - name: billing-usage/Analytics/Conversation Analytics
  - name: billing-usage/Analytics/Run Analytics
  - name: platform/Other
  - name: platform/Other/API metadata
paths:
  /runs/{run_id}/events:
    get:
      tags:
        - execution/Runs/Run Events
      summary: List run events
      description: List run events.
      operationId: listRunEvents
      parameters:
        - schema:
            type: string
            format: uuid
          required: true
          example: 11111111-1111-4111-8111-111111111111
          name: run_id
          in: path
        - schema:
            type: string
            description: >-
              The previous page’s `page_info.next` event ID, excluded from the
              next page. With `sort_order=asc`, returns larger IDs; with
              `sort_order=desc`, returns smaller IDs. If omitted, starts at the
              oldest event for ascending order or the newest for descending
              order.
          required: false
          description: >-
            Opaque page_info.next cursor; reuse with unchanged filters and
            ordering.
          name: cursor
          in: query
        - schema:
            type: integer
            minimum: 1
            maximum: 100
            default: 20
            description: >-
              Maximum number of records in a page, from 1 to 100. Defaults to
              20.
            format: int32
          required: false
          description: Maximum number of records in a page, from 1 to 100. Defaults to 20.
          name: limit
          in: query
        - schema:
            type: string
            enum:
              - asc
              - desc
            default: asc
            description: >-
              Event order. `asc` returns oldest first; `desc` returns newest
              first. Defaults to `asc`.
          required: false
          name: sort_order
          in: query
        - schema:
            type:
              - integer
              - 'null'
            minimum: 0
            maximum: 9007199254740991
            description: >-
              Deprecated. Use `cursor`. Accepted as an ascending cursor; 0 means
              no cursor.
          required: false
          name: after_event_id
          in: query
        - schema:
            type: string
            enum:
              - fact
              - delta
            description: >-
              Event class to include: `fact` for state changes or `delta` for
              streaming fragments. If omitted, returns both.
          required: false
          description: The event class associated with this record.
          name: event_class
          in: query
        - schema:
            type: array
            items:
              type: string
            maxItems: 32
          required: false
          description: >-
            Filter by event_type. Repeat the query parameter for multiple
            values; comma-separated values remain a compatibility alias. Values
            within this filter use OR; different filters use AND.
          style: form
          explode: true
          name: event_type
          in: query
        - schema:
            type: string
            enum:
              - 'true'
              - 'false'
            description: >-
              If true, returns only events with `is_error: true`. If false,
              returns other events. If omitted, returns both.
          required: false
          name: is_error
          in: query
        - schema:
            type: string
            format: date-time
            description: >-
              Only events created at or after this instant (ISO 8601 with a UTC
              offset, inclusive). A summary bucket start can be sent as is.
          required: false
          name: start
          in: query
        - schema:
            type: string
            format: date-time
            description: >-
              Only events created before this instant (ISO 8601 with a UTC
              offset, exclusive). Must be later than start. A summary bucket end
              can be sent as is.
          required: false
          name: end
          in: query
        - schema:
            type: string
            minLength: 1
            description: >-
              Only events whose envelope span_id, as served to the caller, is
              exactly this value (tool:<id>, message:<id>, step:<id>,
              input_request:<id>, run:<id>, with a non-empty <id>).
          required: false
          name: span_id
          in: query
        - schema:
            type: string
            minLength: 1
            description: >-
              Only events whose envelope turn_id, as served to the caller, is
              exactly this value (message:<id>, with a non-empty <id>).
          required: false
          name: turn_id
          in: query
        - schema:
            type: string
            minLength: 1
            maxLength: 200
            description: >-
              Case-insensitive substring of the event payload JSON as served to
              the caller (1-200 characters after trimming, matched literally).
          required: false
          name: search
          in: query
        - schema:
            type: string
            enum:
              - 'true'
              - 'false'
            default: 'false'
            description: >-
              If true, includes events from readable descendant runs, up to 16
              generations. Results share one `event_id` order and cursor. Each
              event retains its `run_id` and the payload visibility permitted
              for that run. Runs the caller cannot read are excluded. Defaults
              to false.


              If at least one descendant is included, task or workflow runs
              without stored events do not contribute synthetic lifecycle
              events. Event IDs are allocated before commit. During active
              writes, ascending pagination can pass an ID that another run
              commits later.
          required: false
          name: include_descendants
          in: query
      responses:
        '200':
          description: >-
            Run events. Editors read diagnostic payloads; viewers read public
            ones.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListRunEventsResponse'
              examples:
                example:
                  summary: Example response
                  value:
                    data:
                      - event_id: 42
                        event_type: MODEL_CALL_COMPLETED
                        payload:
                          type: MODEL_CALL_COMPLETED
                          provider: example-provider
                          model: example-model
                          inputTokens: 120
                          outputTokens: 30
                          cacheCreationTokens: 0
                          cacheReadTokens: 0
                          totalTokens: 150
                          costCredits: '0.001'
                          latencyMs: 800
                          usageCaptureStatus: complete
                          providerRequestId: request_example
                          modelCallContextEventId: null
                        is_error: false
                        created_at: '2026-10-02T10:00:00Z'
                        run_id: 11111111-1111-4111-8111-111111111111
                        event_class: fact
                        span_id: span_example
                        parent_span_id: null
                        turn_id: null
                        origin_event_type: MODEL_CALL_COMPLETED
                        origin_custom_name: null
                        unrecoverable_fields: []
                    page_info:
                      next: null
        '400':
          description: Bad request
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 400
        '401':
          description: Unauthorized
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 401
        '403':
          description: Forbidden
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 403
        '404':
          description: Not found
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 404
        '429':
          description: Rate limit exceeded
          headers:
            Retry-After:
              schema:
                type: integer
                format: int32
                minimum: 1
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 429
        '503':
          description: Service unavailable
          content:
            application/problem+json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/TargetRunProblem'
                  - properties:
                      status:
                        const: 503
      security:
        - bearerAuth: []
        - apiKeyAuth: []
        - runExecutionAuth: []
components:
  schemas:
    ListRunEventsResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/RunEvent'
        page_info:
          $ref: '#/components/schemas/RunsPageInfo'
      required:
        - data
        - page_info
    TargetRunProblem:
      type: object
      properties:
        type:
          type: string
          description: Problem type URI reference.
        title:
          type: string
        status:
          type: integer
          minimum: 400
          maximum: 599
          format: int64
        code:
          type: string
          minLength: 1
          maxLength: 128
        cause:
          type: string
          enum:
            - schedule_concurrency_forbidden
            - schedule_fire_in_progress
            - schedule_run_limit_reached
          description: Schedule admission refusal.
        detail:
          type: string
        instance:
          type: string
        errors:
          type: array
          items:
            type: object
            properties:
              field:
                type: string
              message:
                type: string
            required:
              - field
              - message
      required:
        - type
        - title
        - status
        - code
    RunEvent:
      oneOf:
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - RUN_STARTED
            payload:
              anyOf:
                - $ref: '#/components/schemas/RunStartedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - RUN_STARTED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - RUN_FINISHED
            payload:
              anyOf:
                - $ref: '#/components/schemas/RunFinishedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - RUN_FINISHED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - RUN_ERROR
            payload:
              anyOf:
                - $ref: '#/components/schemas/RunErrorPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - RUN_ERROR
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TEXT_MESSAGE_START
            payload:
              anyOf:
                - $ref: '#/components/schemas/TextMessageStartPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TEXT_MESSAGE_START
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TEXT_MESSAGE_CONTENT
            payload:
              anyOf:
                - $ref: '#/components/schemas/TextMessageContentPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TEXT_MESSAGE_CONTENT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TEXT_MESSAGE_END
            payload:
              anyOf:
                - $ref: '#/components/schemas/TextMessageEndPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TEXT_MESSAGE_END
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TOOL_CALL_START
            payload:
              anyOf:
                - $ref: '#/components/schemas/ToolCallStartPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TOOL_CALL_START
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TOOL_CALL_ARGS
            payload:
              anyOf:
                - $ref: '#/components/schemas/ToolCallArgsPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TOOL_CALL_ARGS
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TOOL_CALL_CHUNK
            payload:
              anyOf:
                - $ref: '#/components/schemas/ToolCallChunkPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TOOL_CALL_CHUNK
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TOOL_CALL_END
            payload:
              anyOf:
                - $ref: '#/components/schemas/ToolCallEndPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TOOL_CALL_END
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - TOOL_CALL_RESULT
            payload:
              anyOf:
                - $ref: '#/components/schemas/ToolCallResultPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - TOOL_CALL_RESULT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - STATE_SNAPSHOT
            payload:
              anyOf:
                - $ref: '#/components/schemas/StateSnapshotPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - STATE_SNAPSHOT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - STATE_DELTA
            payload:
              anyOf:
                - $ref: '#/components/schemas/StateDeltaPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - STATE_DELTA
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - MESSAGES_SNAPSHOT
            payload:
              anyOf:
                - $ref: '#/components/schemas/MessagesSnapshotPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - MESSAGES_SNAPSHOT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - STEP_STARTED
            payload:
              anyOf:
                - $ref: '#/components/schemas/StepStartedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - STEP_STARTED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - STEP_FINISHED
            payload:
              anyOf:
                - $ref: '#/components/schemas/StepFinishedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - STEP_FINISHED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_START
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningStartPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_START
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_MESSAGE_START
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningMessageStartPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_MESSAGE_START
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_MESSAGE_CONTENT
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningMessageContentPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_MESSAGE_CONTENT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_MESSAGE_END
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningMessageEndPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_MESSAGE_END
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_CONTENT
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningContentPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_CONTENT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - REASONING_END
            payload:
              anyOf:
                - $ref: '#/components/schemas/ReasoningEndPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - REASONING_END
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - ACTIVITY_SNAPSHOT
            payload:
              anyOf:
                - $ref: '#/components/schemas/ActivitySnapshotPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - ACTIVITY_SNAPSHOT
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - ACTIVITY_DELTA
            payload:
              anyOf:
                - $ref: '#/components/schemas/ActivityDeltaPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - ACTIVITY_DELTA
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_AUTHORIZATION_SEALED
            payload:
              anyOf:
                - $ref: '#/components/schemas/AgentRunAuthorizationSealedPayload'
                - $ref: >-
                    #/components/schemas/AgentRunAuthorizationSealedPayloadRedacted
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_REQUEST_ENQUEUED
            payload:
              anyOf:
                - $ref: '#/components/schemas/AgentRunRequestEnqueuedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - AGENT_RUN_REQUEST_ENQUEUED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_DEFAULT_CHAT_START_ENQUEUED
            payload:
              anyOf:
                - $ref: '#/components/schemas/AgentRunDefaultChatStartEnqueuedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - AGENT_RUN_DEFAULT_CHAT_START_ENQUEUED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_TOOL_RESULT_SUBMITTED
            payload:
              anyOf:
                - $ref: '#/components/schemas/AgentRunToolResultSubmittedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - AGENT_RUN_TOOL_RESULT_SUBMITTED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_TOOL_RESULT_DELIVERY_FAILED
            payload:
              anyOf:
                - $ref: '#/components/schemas/AgentRunToolResultDeliveryFailedPayload'
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - AGENT_RUN_TOOL_RESULT_DELIVERY_FAILED
                  required:
                    - type
                  additionalProperties: false
            is_error:
              type: boolean
            created_at:
              type: string
            run_id:
              type: string
              format: uuid
              description: Run identifier associated with the record.
            event_class:
              type: string
              enum:
                - fact
                - delta
              description: The event class associated with this record.
            span_id:
              type: string
              minLength: 1
              description: The span id associated with this record.
            parent_span_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The parent span id associated with this record.
            turn_id:
              type:
                - string
                - 'null'
              minLength: 1
              description: The turn id associated with this record.
            origin_event_type:
              type: string
              minLength: 1
              description: The origin event type associated with this record.
            origin_custom_name:
              type:
                - string
                - 'null'
              minLength: 1
              description: The origin custom name associated with this record.
            unrecoverable_fields:
              type: array
              items:
                type: string
                minLength: 1
                description: One unrecoverable field item associated with this record.
              description: List of unrecoverable fields associated with this record.
          required:
            - event_id
            - event_type
            - payload
            - is_error
            - created_at
            - run_id
            - event_class
            - span_id
            - parent_span_id
            - turn_id
            - origin_event_type
            - origin_custom_name
            - unrecoverable_fields
          additionalProperties: false
        - type: object
          properties:
            event_id:
              type: integer
              minimum: 0
            event_type:
              type: string
              enum:
                - AGENT_RUN_INTEGRATION_CONNECTION_REFUSED
            payload:
              anyOf:
                - $ref: >-
                    #/components/schemas/AgentRunIntegrationConnectionRefusedPayload
                - type: object
                  properties:
                    type:
[...]
